const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Travel_bookingsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const travel_bookings = await db.travel_bookings.create(
      {
        id: data.id || undefined,

        type: data.type || null,
        provider: data.provider || null,
        start: data.start || null,
        end: data.end || null,
        cost: data.cost || null,
        policy_result: data.policy_result || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await travel_bookings.setEmployee(data.employee || null, {
      transaction,
    });

    await travel_bookings.setOrganizations(data.organizations || null, {
      transaction,
    });

    return travel_bookings;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const travel_bookingsData = data.map((item, index) => ({
      id: item.id || undefined,

      type: item.type || null,
      provider: item.provider || null,
      start: item.start || null,
      end: item.end || null,
      cost: item.cost || null,
      policy_result: item.policy_result || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const travel_bookings = await db.travel_bookings.bulkCreate(
      travel_bookingsData,
      { transaction },
    );

    // For each item created, replace relation files

    return travel_bookings;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const travel_bookings = await db.travel_bookings.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.type !== undefined) updatePayload.type = data.type;

    if (data.provider !== undefined) updatePayload.provider = data.provider;

    if (data.start !== undefined) updatePayload.start = data.start;

    if (data.end !== undefined) updatePayload.end = data.end;

    if (data.cost !== undefined) updatePayload.cost = data.cost;

    if (data.policy_result !== undefined)
      updatePayload.policy_result = data.policy_result;

    updatePayload.updatedById = currentUser.id;

    await travel_bookings.update(updatePayload, { transaction });

    if (data.employee !== undefined) {
      await travel_bookings.setEmployee(
        data.employee,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await travel_bookings.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return travel_bookings;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const travel_bookings = await db.travel_bookings.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of travel_bookings) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of travel_bookings) {
        await record.destroy({ transaction });
      }
    });

    return travel_bookings;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const travel_bookings = await db.travel_bookings.findByPk(id, options);

    await travel_bookings.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await travel_bookings.destroy({
      transaction,
    });

    return travel_bookings;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const travel_bookings = await db.travel_bookings.findOne(
      { where },
      { transaction },
    );

    if (!travel_bookings) {
      return travel_bookings;
    }

    const output = travel_bookings.get({ plain: true });

    output.employee = await travel_bookings.getEmployee({
      transaction,
    });

    output.organizations = await travel_bookings.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'employee',

        where: filter.employee
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.employee
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.employee
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.provider) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('travel_bookings', 'provider', filter.provider),
        };
      }

      if (filter.policy_result) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'travel_bookings',
            'policy_result',
            filter.policy_result,
          ),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              start: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              end: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.startRange) {
        const [start, end] = filter.startRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            start: {
              ...where.start,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            start: {
              ...where.start,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.endRange) {
        const [start, end] = filter.endRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            end: {
              ...where.end,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            end: {
              ...where.end,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.costRange) {
        const [start, end] = filter.costRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            cost: {
              ...where.cost,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            cost: {
              ...where.cost,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.type) {
        where = {
          ...where,
          type: filter.type,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.travel_bookings.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('travel_bookings', 'provider', query),
        ],
      };
    }

    const records = await db.travel_bookings.findAll({
      attributes: ['id', 'provider'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['provider', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.provider,
    }));
  }
};
